import * as i1 from '@angular-three/core';
import { NgtStore } from '@angular-three/core';
import { DOCUMENT } from '@angular/common';
import * as i0 from '@angular/core';
import { Directive, Inject, Input, NgModule } from '@angular/core';
import Stats from 'three/examples/jsm/libs/stats.module';

class NgtStats extends NgtStore {
    constructor(zone, animationFrameStore, canvasStore, document) {
        super();
        this.zone = zone;
        this.animationFrameStore = animationFrameStore;
        this.canvasStore = canvasStore;
        this.animationUuid = '';
        this.node = document.body;
    }
    ngOnInit() {
        this.zone.runOutsideAngular(() => {
            this.onCanvasReady(this.canvasStore.ready$, () => {
                if (this.parent) {
                    this.node = this.parent;
                }
                this.stats = Stats();
                this.node.appendChild(this.stats.dom);
                this.animationUuid = this.animationFrameStore.register({
                    callback: this.stats.update.bind(this.stats),
                });
                return () => {
                    if (this.stats) {
                        this.animationFrameStore.unregister(this.animationUuid);
                        this.stats.end();
                        this.node.removeChild(this.stats.dom);
                    }
                };
            }, true);
        });
    }
}
NgtStats.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtStats, deps: [{ token: i0.NgZone }, { token: i1.NgtAnimationFrameStore }, { token: i1.NgtCanvasStore }, { token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Directive });
NgtStats.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.2", type: NgtStats, selector: "ngt-stats", inputs: { parent: "parent" }, exportAs: ["ngtStats"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtStats, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ngt-stats',
                    exportAs: 'ngtStats',
                }]
        }], ctorParameters: function () { return [{ type: i0.NgZone }, { type: i1.NgtAnimationFrameStore }, { type: i1.NgtCanvasStore }, { type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }]; }, propDecorators: { parent: [{
                type: Input
            }] } });
class NgtStatsModule {
}
NgtStatsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtStatsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtStatsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtStatsModule, declarations: [NgtStats], exports: [NgtStats] });
NgtStatsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtStatsModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.2", ngImport: i0, type: NgtStatsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtStats],
                    exports: [NgtStats],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { NgtStats, NgtStatsModule };
//# sourceMappingURL=angular-three-core-stats.mjs.map
