import { ElementRef, EventEmitter, NgZone, OnInit } from '@angular/core';
import { NgtLoop } from './services/loop';
import { NgtAnimationFrameStore } from './stores/animation-frame';
import { NgtCanvasStore } from './stores/canvas';
import { NgtEventsStore } from './stores/events';
import { NgtStore } from './stores/store';
import type { NgtCameraOptions, NgtCreatedState, NgtDpr, NgtGLOptions, NgtPerformanceOptions, NgtRaycaster, NgtSceneOptions, NgtSize } from './types';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
export declare class NgtCanvas extends NgtStore implements OnInit {
    private canvasStore;
    private eventsStore;
    private animationFrameStore;
    private loop;
    private zone;
    hostClass: boolean;
    set vr(vr: boolean | '');
    set linear(linear: boolean | '');
    set flat(flat: boolean | '');
    set frameloop(frameloop: 'always' | 'demand' | 'never');
    set orthographic(orthographic: boolean | '');
    set performance(performance: NgtPerformanceOptions);
    set size(size: NgtSize);
    set dpr(dpr: NgtDpr);
    set clock(clock: THREE.Clock);
    set raycaster(raycaster: Partial<NgtRaycaster>);
    set shadows(shadows: boolean | Partial<THREE.WebGLShadowMap>);
    set camera(cameraOptions: NgtCameraOptions);
    set scene(sceneOptions: NgtSceneOptions);
    set gl(glOptions: NgtGLOptions);
    initialLog: boolean;
    projectContent: boolean;
    created: EventEmitter<NgtCreatedState>;
    pointermissed: EventEmitter<MouseEvent>;
    rendererCanvas: ElementRef<HTMLCanvasElement>;
    constructor(canvasStore: NgtCanvasStore, eventsStore: NgtEventsStore, animationFrameStore: NgtAnimationFrameStore, loop: NgtLoop, zone: NgZone);
    ngOnInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtCanvas, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtCanvas, "ngt-canvas", never, { "vr": "vr"; "linear": "linear"; "flat": "flat"; "frameloop": "frameloop"; "orthographic": "orthographic"; "performance": "performance"; "size": "size"; "dpr": "dpr"; "clock": "clock"; "raycaster": "raycaster"; "shadows": "shadows"; "camera": "camera"; "scene": "scene"; "gl": "gl"; "initialLog": "initialLog"; "projectContent": "projectContent"; }, { "created": "created"; "pointermissed": "pointermissed"; }, never, ["*"]>;
}
export declare class NgtCoreModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtCoreModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NgtCoreModule, [typeof NgtCanvas], [typeof i1.CommonModule], [typeof NgtCanvas]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NgtCoreModule>;
}
