import { EventEmitter } from '@angular/core';
import * as THREE from 'three';
import type { NgtColor, NgtEuler, NgtEvent, NgtObject3dProps, NgtQuaternion, NgtVector3, UnknownRecord } from '../types';
import { Controller } from './controller';
import * as i0 from "@angular/core";
export declare class NgtObjectInputsController extends Controller {
    name?: string;
    set position(position: NgtVector3 | undefined);
    get position(): NgtVector3 | undefined;
    private _position?;
    set rotation(rotation: NgtEuler | undefined);
    get rotation(): NgtEuler | undefined;
    private _rotation?;
    set quaternion(quaternion: NgtQuaternion | undefined);
    get quaternion(): NgtQuaternion | undefined;
    private _quaternion?;
    set scale(scale: NgtVector3 | undefined);
    get scale(): NgtVector3 | undefined;
    private _scale?;
    set color(color: NgtColor | undefined);
    get color(): NgtColor | undefined;
    private _color?;
    userData?: UnknownRecord;
    castShadow?: boolean;
    receiveShadow?: boolean;
    visible: boolean;
    matrixAutoUpdate: boolean;
    dispose?: (() => void) | null;
    raycast?: THREE.Object3D['raycast'] | null;
    appendMode: 'immediate' | 'root' | 'none';
    appendTo?: THREE.Object3D | (() => THREE.Object3D);
    click: EventEmitter<NgtEvent<MouseEvent>>;
    contextmenu: EventEmitter<NgtEvent<MouseEvent>>;
    dblclick: EventEmitter<NgtEvent<MouseEvent>>;
    pointerup: EventEmitter<NgtEvent<PointerEvent>>;
    pointerdown: EventEmitter<NgtEvent<PointerEvent>>;
    pointerover: EventEmitter<NgtEvent<PointerEvent>>;
    pointerout: EventEmitter<NgtEvent<PointerEvent>>;
    pointerenter: EventEmitter<NgtEvent<PointerEvent>>;
    pointerleave: EventEmitter<NgtEvent<PointerEvent>>;
    pointermove: EventEmitter<NgtEvent<PointerEvent>>;
    pointermissed: EventEmitter<NgtEvent<PointerEvent>>;
    pointercancel: EventEmitter<NgtEvent<PointerEvent>>;
    wheel: EventEmitter<NgtEvent<WheelEvent>>;
    get object3dProps(): NgtObject3dProps;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtObjectInputsController, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtObjectInputsController, "    ngt-primitive,    ngt-bone,    ngt-group,    ngt-lod,    ngt-points,    ngt-mesh,    ngt-instanced-mesh,    ngt-skinned-mesh,    ngt-audio,    ngt-positional-audio,    ngt-line,    ngt-line-loop,    ngt-line-segments,    ngt-light-probe,    ngt-ambient-light,    ngt-ambient-light-probe,    ngt-hemisphere-light,    ngt-hemisphere-light-probe,    ngt-directional-light,    ngt-point-light,    ngt-spot-light,    ngt-rect-area-light,    ngt-arrow-helper,    ngt-axes-helper,    ngt-box3-helper,    ngt-grid-helper,    ngt-plane-helper,    ngt-polar-grid-helper,    ngt-sprite,    ngt-camera,    ngt-perspective-camera,    ngt-orthographic-camera,    ngt-array-camera,    ngt-stereo-camera,    ngt-cube-camera,    ngt-soba-billboard,    ngt-soba-detailed,    ngt-soba-line,    ngt-soba-quadratic-bezier-line,    ngt-soba-cubic-bezier-line,    ngt-soba-orthographic-camera,    ngt-soba-gizmo-helper,    ngt-soba-gizmo-viewport,    ngt-soba-gizmo-axis-head,    ngt-soba-transform-controls,    ngt-soba-center,    ngt-soba-bounds,    ngt-soba-float,    ngt-soba-stage,    ngt-soba-backdrop,    ngt-soba-spot-light,    ngt-soba-html,    ngt-soba-contact-shadows,    ngt-soba-text  ", ["ngtObjectInputsController"], { "name": "name"; "position": "position"; "rotation": "rotation"; "quaternion": "quaternion"; "scale": "scale"; "color": "color"; "userData": "userData"; "castShadow": "castShadow"; "receiveShadow": "receiveShadow"; "visible": "visible"; "matrixAutoUpdate": "matrixAutoUpdate"; "dispose": "dispose"; "raycast": "raycast"; "appendMode": "appendMode"; "appendTo": "appendTo"; }, { "click": "click"; "contextmenu": "contextmenu"; "dblclick": "dblclick"; "pointerup": "pointerup"; "pointerdown": "pointerdown"; "pointerover": "pointerover"; "pointerout": "pointerout"; "pointerenter": "pointerenter"; "pointerleave": "pointerleave"; "pointermove": "pointermove"; "pointermissed": "pointermissed"; "pointercancel": "pointercancel"; "wheel": "wheel"; }, never>;
}
export declare class NgtObjectInputsControllerModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtObjectInputsControllerModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NgtObjectInputsControllerModule, [typeof NgtObjectInputsController], never, [typeof NgtObjectInputsController]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NgtObjectInputsControllerModule>;
}
export declare const NGT_OBJECT_INPUTS_WATCHED_CONTROLLER: import("@angular/core").InjectionToken<NgtObjectInputsController>, NGT_OBJECT_INPUTS_CONTROLLER_PROVIDER: import("@angular/core").Provider[];
