import { EventEmitter, NgZone, OnDestroy } from '@angular/core';
import * as THREE from 'three';
import { NgtAnimationFrameStore } from '../stores/animation-frame';
import { NgtCanvasStore } from '../stores/canvas';
import { NgtEventsStore } from '../stores/events';
import { NgtStore } from '../stores/store';
import type { AnyFunction, NgtRender } from '../types';
import { Controller } from './controller';
import { NgtObjectInputsController } from './object-inputs.controller';
import * as i0 from "@angular/core";
import * as i1 from "./object-inputs.controller";
export declare class NgtObjectController extends Controller implements OnDestroy {
    private store;
    private zone;
    private canvasStore;
    private eventsStore;
    private animationFrameStore;
    private objectInputsController;
    private parentObjectFn;
    private hostParentObjectFn;
    priority: number;
    useHostParent: boolean;
    animateReady: EventEmitter<{
        state: NgtRender;
        object: THREE.Object3D;
    }>;
    private readonly $object;
    get object(): THREE.Object3D;
    private initSubscription?;
    private _initFn?;
    set initFn(v: () => THREE.Object3D);
    get initFn(): () => THREE.Object3D;
    private inputChanges$;
    constructor(store: NgtStore, zone: NgZone, canvasStore: NgtCanvasStore, eventsStore: NgtEventsStore, animationFrameStore: NgtAnimationFrameStore, objectInputsController: NgtObjectInputsController, parentObjectFn: AnyFunction, hostParentObjectFn: AnyFunction);
    ngOnInit(): void;
    init(): void;
    ngOnDestroy(): void;
    private appendToParent;
    private addToScene;
    private addToParent;
    private eventNameToHandler;
    private switch;
    private remove;
    private get appendTo();
    private applyCustomProps;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtObjectController, [null, null, null, null, null, null, { optional: true; skipSelf: true; }, { optional: true; skipSelf: true; }]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtObjectController, "        ngt-primitive,        ngt-bone,        ngt-group,        ngt-lod,        ngt-points,        ngt-mesh,        ngt-instanced-mesh,        ngt-skinned-mesh,        ngt-audio,        ngt-positional-audio,        ngt-line,        ngt-line-loop,        ngt-line-segments,        ngt-light-probe,        ngt-ambient-light,        ngt-ambient-light-probe,        ngt-hemisphere-light,        ngt-hemisphere-light-probe,        ngt-directional-light,        ngt-point-light,        ngt-spot-light,        ngt-rect-area-light,        ngt-arrow-helper,        ngt-axes-helper,        ngt-box3-helper,        ngt-grid-helper,        ngt-plane-helper,        ngt-polar-grid-helper,        ngt-sprite,        ngt-camera,        ngt-perspective-camera,        ngt-orthographic-camera,        ngt-array-camera,        ngt-stereo-camera,        ngt-cube-camera    ", ["ngtObjectController"], { "priority": "priority"; "useHostParent": "useHostParent"; }, { "animateReady": "animateReady"; }, never>;
}
export declare class NgtObjectControllerModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtObjectControllerModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NgtObjectControllerModule, [typeof NgtObjectController], never, [typeof NgtObjectController, typeof i1.NgtObjectInputsControllerModule]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NgtObjectControllerModule>;
}
export declare const NGT_OBJECT_WATCHED_CONTROLLER: import("@angular/core").InjectionToken<NgtObjectController>, NGT_OBJECT_CONTROLLER_PROVIDER: import("@angular/core").Provider[];
