import { NgZone, OnChanges, OnDestroy, OnInit } from '@angular/core';
import * as THREE from 'three';
import { NgtCanvasStore } from '../stores/canvas';
import { NgtStore } from '../stores/store';
import type { AnyConstructor } from '../types';
import { NgtGeometry } from './geometry';
import * as i0 from "@angular/core";
export declare abstract class NgtAttribute<TAttribute extends THREE.BufferAttribute | THREE.InterleavedBufferAttribute = THREE.BufferAttribute> extends NgtStore implements OnInit, OnChanges, OnDestroy {
    protected zone: NgZone;
    protected geometryDirective: NgtGeometry;
    protected canvasStore: NgtCanvasStore;
    attach?: THREE.BuiltinShaderAttributeName | string;
    abstract attributeType: AnyConstructor<TAttribute>;
    constructor(zone: NgZone, geometryDirective: NgtGeometry, canvasStore: NgtCanvasStore);
    private _attributeArgs;
    protected set attributeArgs(v: unknown | unknown[]);
    private _attribute?;
    private _defaultValue?;
    private initSubscription?;
    ngOnChanges(): void;
    ngOnInit(): void;
    private init;
    ngOnDestroy(): void;
    get attribute(): TAttribute | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtAttribute<any>, [null, { optional: true; }, null]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtAttribute<any>, never, never, { "attach": "attach"; }, {}, never>;
}
