import { NgZone, OnInit } from '@angular/core';
import * as THREE from 'three';
import { NgtCanvasStore } from '../stores/canvas';
import { NgtStore } from '../stores/store';
import type { AnyConstructor } from '../types';
import { NgtGeometry } from './geometry';
import * as i0 from "@angular/core";
export declare abstract class NgtCurve<TCurve extends THREE.Curve<THREE.Vector> = THREE.Curve<THREE.Vector>> extends NgtStore implements OnInit {
    protected zone: NgZone;
    protected geometryDirective: NgtGeometry;
    protected canvasStore: NgtCanvasStore;
    divisions?: number;
    abstract curveType: AnyConstructor<TCurve>;
    private _curveArgs;
    protected set curveArgs(v: unknown | unknown[]);
    private initSubscription?;
    constructor(zone: NgZone, geometryDirective: NgtGeometry, canvasStore: NgtCanvasStore);
    private _curve?;
    ngOnInit(): void;
    private init;
    get curve(): TCurve | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtCurve<any>, [null, { optional: true; }, null]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtCurve<any>, never, never, { "divisions": "divisions"; }, {}, never>;
}
