import { EventEmitter, OnInit } from '@angular/core';
import * as THREE from 'three';
import { NgtObjectController } from '../controllers/object.controller';
import type { AnyConstructor } from '../types';
import * as i0 from "@angular/core";
export declare abstract class NgtLight<TLight extends THREE.Light = THREE.Light> implements OnInit {
    protected objectController: NgtObjectController;
    ready: EventEmitter<TLight>;
    abstract lightType: AnyConstructor<TLight>;
    intensity?: number;
    shadow?: Partial<THREE.LightShadow>;
    private initializing;
    constructor(objectController: NgtObjectController);
    private _lightArgs;
    protected set lightArgs(v: unknown | unknown[]);
    private _light;
    ngOnInit(): void;
    get light(): TLight;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtLight<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtLight<any>, never, never, { "intensity": "intensity"; "shadow": "shadow"; }, { "ready": "ready"; }, never>;
}
