import { NgZone, OnInit } from '@angular/core';
import * as THREE from 'three';
import { NgtCanvasStore } from '../stores/canvas';
import { NgtStore } from '../stores/store';
import type { AnyConstructor, AnyFunction } from '../types';
import * as i0 from "@angular/core";
interface NgtMaterialState<TMaterial extends THREE.Material = THREE.Material, TMaterialParameters extends THREE.MaterialParameters = THREE.MaterialParameters> {
    material: TMaterial;
    materialParameters: TMaterialParameters;
}
export declare abstract class NgtMaterial<TMaterialParameters extends THREE.MaterialParameters = THREE.MaterialParameters, TMaterial extends THREE.Material = THREE.Material> extends NgtStore<NgtMaterialState<TMaterial, TMaterialParameters>> implements OnInit {
    protected zone: NgZone;
    protected canvasStore: NgtCanvasStore;
    protected parentObjectFactory: AnyFunction;
    ready: import("rxjs").Observable<TMaterial>;
    set parameters(v: TMaterialParameters | undefined);
    get parameters(): TMaterialParameters | undefined;
    constructor(zone: NgZone, canvasStore: NgtCanvasStore, parentObjectFactory: AnyFunction);
    abstract materialType: AnyConstructor<TMaterial>;
    get material(): TMaterial;
    ngOnInit(): void;
    private readonly init;
    private readonly setParameters;
    private convertColorToLinear;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtMaterial<any, any>, [null, null, { optional: true; }]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtMaterial<any, any>, never, never, { "parameters": "parameters"; }, { "ready": "ready"; }, never>;
}
export {};
