import { NgZone, OnInit } from '@angular/core';
import * as THREE from 'three';
import { NgtAnimationFrameStore } from '../stores/animation-frame';
import { NgtCanvasStore } from '../stores/canvas';
import { NgtStore } from '../stores/store';
import type { AnyConstructor, AnyFunction } from '../types';
import * as i0 from "@angular/core";
export declare abstract class NgtObjectHelper<TObjectHelper extends THREE.Object3D> extends NgtStore<{
    args: unknown[];
}> implements OnInit {
    protected objectFn: AnyFunction;
    protected canvasStore: NgtCanvasStore;
    protected animationFrameStore: NgtAnimationFrameStore;
    protected zone: NgZone;
    abstract objectHelperType: AnyConstructor<TObjectHelper>;
    protected set objectHelperArgs(v: unknown | unknown[]);
    private _object?;
    constructor(objectFn: AnyFunction, canvasStore: NgtCanvasStore, animationFrameStore: NgtAnimationFrameStore, zone: NgZone);
    ngOnInit(): void;
    private _objectHelper?;
    get objectHelper(): TObjectHelper | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtObjectHelper<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtObjectHelper<any>, never, never, {}, {}, never>;
}
