import { EventEmitter, NgZone, OnDestroy, OnInit } from '@angular/core';
import * as THREE from 'three';
import { NgtCanvasStore } from '../stores/canvas';
import { NgtStore } from '../stores/store';
import type { AnyConstructor } from '../types';
import * as i0 from "@angular/core";
export declare abstract class NgtTexture<TTexture extends THREE.Texture = THREE.Texture> extends NgtStore<{
    texture: TTexture;
}> implements OnInit, OnDestroy {
    protected zone: NgZone;
    protected canvasStore: NgtCanvasStore;
    ready: EventEmitter<TTexture>;
    abstract textureType: AnyConstructor<TTexture>;
    private _textureArgs;
    private initSubscription?;
    protected set textureArgs(v: unknown | unknown[]);
    private _texture?;
    constructor(zone: NgZone, canvasStore: NgtCanvasStore);
    ngOnInit(): void;
    get texture(): TTexture | undefined;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtTexture<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtTexture<any>, never, never, {}, { "ready": "ready"; }, never>;
}
